/*************************************************************************
Title:    I2C FM75 irenginys ir LCD
Author:   Savel
File:     
Software: AVR-GCC 3.3
Hardware: ATMEGA16 testine plokste
**************************************************************************/
#define F_CPU 12000000UL
#define LM75_ADDR       (LM75_ADDR_BASE + 0) //pasitikrinti

#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "lcd.h"
#include <util\delay.h>

#include "i2c.c"
#include "lm75.c"

int sensors_init(void)
{
	i2c_init();
	return lm75_configure(LM75_ADDR, 0x60); //cia komanda FM75, daugiau tikslumo. Skaityti FM75/LM75 datasheeta.
}

int main(void)
{
    char buffer[16];
    unsigned char dst[2];
	int x=0;

	sensors_init();
    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);
    /* turn off cursor */
    lcd_command(LCD_DISP_ON); 
	lcd_clrscr();
	lcd_puts("FM75 sensorius");
    for (;;) { /* loop forever */
		dst[0]=0; dst[1]=0;
		// temperaturos nuskaitymas is FM75 cipo 
			lcd_gotoxy(0,1);
			x = lm75_readRegister(LM75_ADDR, LM75_REG_TEMP, &dst[0], 2);
			if (x==0){
			x=dst[0];
			itoa( x, buffer, 10);
			lcd_puts("temp:         ");
			lcd_gotoxy(5,1);
			lcd_puts(buffer);
			lcd_puts(".");
			x=dst[1]; // Cia skaiciuojam po kablelio. 1/16 laipsnio.
			if (x<1) {lcd_puts("0");}
			if (x<17) {lcd_puts("0");}
			x=dst[1]*4;
			itoa( x, buffer, 10);
			lcd_puts(buffer);
			} else {lcd_puts("Sensor error "); }
			for (x=0;x<10;x++) { _delay_ms(20); }
		}
}
